Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.map
Class LazyMap

    java.lang.Object
      org.apache.commons.collections.map.AbstractMapDecorator
          org.apache.commons.collections.map.LazyMap

All Implemented Interfaces:
  java.io.Serializable, java.util.Map

Direct Known Subclasses:
  LazySortedMap

    public class LazyMap

extends AbstractMapDecorator
implements java.util.Map, java.io.Serializable

Decorates another `Map` to create objects in the map on demand.

When the `get(Object)` method is called with a key that does not exist in the map, the factory is used to create the object. The created object will be added to the map using the requested key.

For instance:

     Factory factory = new Factory() {
         public Object create() {
             return new Date();
         }
     }
     Map lazy = Lazy.map(new HashMap(), factory);
     Object obj = lazy.get("NOW");

After the above code is executed, `obj` will contain a new `Date` instance. Furthermore, that `Date` instance is mapped to the "NOW" key in the map.

Note that LazyMap is not synchronized and is not thread-safe. If you wish to use this map from multiple threads concurrently, you must use appropriate synchronization. The simplest approach is to wrap this map using `Collections.synchronizedMap(Map)`. This class may throw exceptions when accessed by concurrent threads without synchronization.

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne, Paul Jack
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface java.util.Map
`java.util.Map.Entry`

Field Summary
`protected Transformer` | `factory` The factory to use to construct elements

Fields inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`map`

Constructor Summary
`protected` | `LazyMap(java.util.Map map, Factory factory)` Constructor that wraps (not copies).
`protected` | `LazyMap(java.util.Map map, Transformer factory)` Constructor that wraps (not copies).

Method Summary
`static java.util.Map` | `decorate(java.util.Map map, Factory factory)` Factory method to create a lazily instantiated map.
`static java.util.Map` | `decorate(java.util.Map map, Transformer factory)` Factory method to create a lazily instantiated map.
`java.lang.Object` | `get(java.lang.Object key)`

Methods inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`clear, containsKey, containsValue, entrySet, equals, getMap, hashCode, isEmpty, keySet, put, putAll, remove, size, toString, values`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, hashCode, isEmpty, keySet, put, putAll, remove, size, values`

Field Detail

### factory

    protected final Transformer factory

  The factory to use to construct elements

Constructor Detail

### LazyMap

    protected LazyMap(java.util.Map map,
                      Factory factory)

  Constructor that wraps (not copies).

  Parameters:
    `map` - the map to decorate, must not be null
    `factory` - the factory to use, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if map or factory is null

### LazyMap

    protected LazyMap(java.util.Map map,
                      Transformer factory)

  Constructor that wraps (not copies).

  Parameters:
    `map` - the map to decorate, must not be null
    `factory` - the factory to use, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if map or factory is null

Method Detail

### decorate

    public static java.util.Map decorate(java.util.Map map,
                                         Factory factory)

  Factory method to create a lazily instantiated map.

  Parameters:
    `map` - the map to decorate, must not be null
    `factory` - the factory to use, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if map or factory is null

### decorate

    public static java.util.Map decorate(java.util.Map map,
                                         Transformer factory)

  Factory method to create a lazily instantiated map.

  Parameters:
    `map` - the map to decorate, must not be null
    `factory` - the factory to use, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if map or factory is null

### get

    public java.lang.Object get(java.lang.Object key)

  Specified by:
    `get` in interface `java.util.Map`
  Overrides:
    `get` in class `AbstractMapDecorator`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.